import { createContext, createElement, useContext, useEffect, useState, } from 'react';
var EMPTY_OBJECT = {};
export function observe(Child) {
    return function ObserveWrapper(props) {
        var _a = useState(EMPTY_OBJECT), update = _a[1];
        useEffect(function () {
            var observed = Object.values(props)
                .filter(function (prop) { return prop.__p_model && prop.onPatch; })
                .map(function (model) { return model.onPatch(function () { return update({}); }); });
            return function () { return observed.forEach(function (unsub) { return unsub(); }); };
        }, [props]);
        return createElement(Child, props);
    };
}
var ctx = createContext(null);
export var Provider = function (_a) {
    var store = _a.store, children = _a.children;
    return createElement(ctx.Provider, { value: store, children: children });
};
export function connect(Child) {
    return function ConnectWrapper(props) {
        var store = useContext(ctx);
        if (!store)
            throw new Error('Store not found in context');
        var _a = useState(EMPTY_OBJECT), update = _a[1];
        useEffect(function () {
            var unsub = store.onPatch(function () { return update({}); });
            return unsub;
        }, [store]);
        return createElement(Child, Object.assign({ store: store }, props));
    };
}
export function useStore() {
    var store = useContext(ctx);
    if (!store)
        throw new Error('Store not found in context');
    var _a = useState(EMPTY_OBJECT), update = _a[1];
    useEffect(function () {
        var unsub = store.onPatch(function () { return update({}); });
        return unsub;
    }, [store]);
    return store;
}
export function useObserved(store) {
    var _a = useState(EMPTY_OBJECT), update = _a[1];
    useEffect(function () {
        var unsub = store.onPatch(function () { return update({}); });
        return unsub;
    }, [store]);
    return store;
}
//# sourceMappingURL=index.js.map